Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.web.portlet
Interface HandlerMapping

All Known Implementing Classes:
  AbstractHandlerMapping, AbstractMapBasedHandlerMapping, DefaultAnnotationHandlerMapping, ParameterHandlerMapping, PortletModeHandlerMapping, PortletModeParameterHandlerMapping

    public interface HandlerMapping

Interface to be implemented by objects that define a mapping between requests and handler objects.

This class can be implemented by application developers, although this is not necessary, as `PortletModeHandlerMapping`, `ParameterHandlerMapping` and `PortletModeParameterHandlerMapping` are included in the framework. The first is the default if no HandlerMapping bean is registered in the portlet application context.

HandlerMapping implementations can support mapped interceptors but do not have to. A handler will always be wrapped in a `HandlerExecutionChain` instance, optionally accompanied by some `HandlerInterceptor` instances. The DispatcherPortlet will first call each HandlerInterceptor's `preHandle` method in the given order, finally invoking the handler itself if all `preHandle` methods have returned `true`.

The ability to parameterize this mapping is a powerful and unusual capability of this Portlet MVC framework. For example, it is possible to write a custom mapping based on session state, cookie state or many other variables. No other MVC framework seems to be equally flexible.

Note: Implementations can implement the `Ordered` interface to be able to specify a sorting order and thus a priority for getting applied by DispatcherPortlet. Non-Ordered instances get treated as lowest priority.

Author:
  John A. Lewis, Juergen Hoeller
See Also:
  `Ordered`, `AbstractHandlerMapping`, `PortletModeHandlerMapping`, `ParameterHandlerMapping`, `PortletModeParameterHandlerMapping`

Method Summary
`HandlerExecutionChain` | `getHandler(javax.portlet.PortletRequest request)` Return a handler and any interceptors for this request.

Method Detail

### getHandler

    HandlerExecutionChain getHandler(javax.portlet.PortletRequest request)
                                     throws Exception

  Return a handler and any interceptors for this request. The choice may be made on portlet mode, session state, or any factor the implementing class chooses.

  The returned HandlerExecutionChain contains a handler Object, rather than even a tag interface, so that handlers are not constrained in any way. For example, a HandlerAdapter could be written to allow another framework's handler objects to be used.

  Returns `null` if no match was found. This is not an error. The DispatcherPortlet will query all registered HandlerMapping beans to find a match, and only decide there is an error if none can find a handler.

  Parameters:
    `request` - current portlet request
  Returns:
    a HandlerExecutionChain instance containing handler object and any interceptors, or null if no mapping found
  Throws:
    `Exception` - if there is an internal error

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2008 The Spring Framework.